package com.wuban.tron.explore.entity.example;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 按天统计区块表 查询条件example类
 * @author sky
 * @date 2020-11-04
 */
public class BlockDayCensusExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public BlockDayCensusExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

	        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria)this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria)this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria)this;
        }
		
		public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria)this;
        }
			
	            public Criteria andGenBlockAverTimeIsNull() {
            addCriterion("gen_block_aver_time is null");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeIsNotNull() {
            addCriterion("gen_block_aver_time is not null");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeEqualTo(Long value) {
            addCriterion("gen_block_aver_time =", value, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeNotEqualTo(Long value) {
            addCriterion("gen_block_aver_time <>", value, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeIn(List<Long> values) {
            addCriterion("gen_block_aver_time in", values, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeNotIn(List<Long> values) {
            addCriterion("gen_block_aver_time not in", values, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeBetween(Long value1, Long value2) {
            addCriterion("gen_block_aver_time between", value1, value2, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeNotBetween(Long value1, Long value2) {
            addCriterion("gen_block_aver_time not between", value1, value2, "genBlockAverTime");
            return (Criteria)this;
        }
		
		public Criteria andGenBlockAverTimeGreaterThan(Long value) {
            addCriterion("gen_block_aver_time >", value, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeGreaterThanOrEqualTo(Long value) {
            addCriterion("gen_block_aver_time >=", value, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeLessThan(Long value) {
            addCriterion("gen_block_aver_time <", value, "genBlockAverTime");
            return (Criteria)this;
        }

        public Criteria andGenBlockAverTimeLessThanOrEqualTo(Long value) {
            addCriterion("gen_block_aver_time <=", value, "genBlockAverTime");
            return (Criteria)this;
        }
			
	            public Criteria andGenBlockTotalNumIsNull() {
            addCriterion("gen_block_total_num is null");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumIsNotNull() {
            addCriterion("gen_block_total_num is not null");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumEqualTo(Integer value) {
            addCriterion("gen_block_total_num =", value, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumNotEqualTo(Integer value) {
            addCriterion("gen_block_total_num <>", value, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumIn(List<Integer> values) {
            addCriterion("gen_block_total_num in", values, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumNotIn(List<Integer> values) {
            addCriterion("gen_block_total_num not in", values, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumBetween(Integer value1, Integer value2) {
            addCriterion("gen_block_total_num between", value1, value2, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumNotBetween(Integer value1, Integer value2) {
            addCriterion("gen_block_total_num not between", value1, value2, "genBlockTotalNum");
            return (Criteria)this;
        }
		
		public Criteria andGenBlockTotalNumGreaterThan(Integer value) {
            addCriterion("gen_block_total_num >", value, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("gen_block_total_num >=", value, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumLessThan(Integer value) {
            addCriterion("gen_block_total_num <", value, "genBlockTotalNum");
            return (Criteria)this;
        }

        public Criteria andGenBlockTotalNumLessThanOrEqualTo(Integer value) {
            addCriterion("gen_block_total_num <=", value, "genBlockTotalNum");
            return (Criteria)this;
        }
			
	            public Criteria andTotalVolumeIsNull() {
            addCriterion("total_volume is null");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeIsNotNull() {
            addCriterion("total_volume is not null");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeEqualTo(Integer value) {
            addCriterion("total_volume =", value, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeNotEqualTo(Integer value) {
            addCriterion("total_volume <>", value, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeIn(List<Integer> values) {
            addCriterion("total_volume in", values, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeNotIn(List<Integer> values) {
            addCriterion("total_volume not in", values, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeBetween(Integer value1, Integer value2) {
            addCriterion("total_volume between", value1, value2, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeNotBetween(Integer value1, Integer value2) {
            addCriterion("total_volume not between", value1, value2, "totalVolume");
            return (Criteria)this;
        }
		
		public Criteria andTotalVolumeGreaterThan(Integer value) {
            addCriterion("total_volume >", value, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeGreaterThanOrEqualTo(Integer value) {
            addCriterion("total_volume >=", value, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeLessThan(Integer value) {
            addCriterion("total_volume <", value, "totalVolume");
            return (Criteria)this;
        }

        public Criteria andTotalVolumeLessThanOrEqualTo(Integer value) {
            addCriterion("total_volume <=", value, "totalVolume");
            return (Criteria)this;
        }
			
	            public Criteria andCensusDateIsNull() {
            addCriterion("census_date is null");
            return (Criteria)this;
        }

        public Criteria andCensusDateIsNotNull() {
            addCriterion("census_date is not null");
            return (Criteria)this;
        }

        public Criteria andCensusDateEqualTo(String value) {
            addCriterion("census_date =", value, "censusDate");
            return (Criteria)this;
        }

        public Criteria andCensusDateNotEqualTo(String value) {
            addCriterion("census_date <>", value, "censusDate");
            return (Criteria)this;
        }

        public Criteria andCensusDateIn(List<String> values) {
            addCriterion("census_date in", values, "censusDate");
            return (Criteria)this;
        }

        public Criteria andCensusDateNotIn(List<String> values) {
            addCriterion("census_date not in", values, "censusDate");
            return (Criteria)this;
        }

        public Criteria andCensusDateBetween(String value1, String value2) {
            addCriterion("census_date between", value1, value2, "censusDate");
            return (Criteria)this;
        }

        public Criteria andCensusDateNotBetween(String value1, String value2) {
            addCriterion("census_date not between", value1, value2, "censusDate");
            return (Criteria)this;
        }
		
			
		public Criteria andCensusDateLike(String value) {
            addCriterion("census_date like", value, "censusDate");
            return (Criteria)this;
        }

        public Criteria andCensusDateNotLike(String value) {
            addCriterion("census_date not like", value, "censusDate");
            return (Criteria)this;
        }
	            public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria)this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria)this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria)this;
        }
		
		public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria)this;
        }
			
	    	public Criteria andFieldIsNull(final String fieldName) {
            addCriterion(fieldName + " is null");
            return (Criteria) this;
        }
		
	public Criteria andFieldIsNotNull(final String fieldName) {
            addCriterion(fieldName + " is not null");
            return (Criteria) this;
        }
		
	public Criteria andFieldEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " = ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <> ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " in ", values, fieldName);
           return (Criteria) this;
        }
		
	public Criteria andFieldNotIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " not in ", values, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + " between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + "  not between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldGreaterThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " > ", fieldValue, fieldName);
            return (Criteria) this;
        }

	public Criteria andFieldGreaterThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " >= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLessThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " < ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldLessThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + " like ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + "  not like ", fieldValue, fieldName);
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
